#ifndef _H_2B00C1E74DE40F6CD5834F7742693179_FollowWaypoints__H_
#define _H_2B00C1E74DE40F6CD5834F7742693179_FollowWaypoints__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "geometry_msgs/msg/dds_opensplice/PoseStamped_.h"
#include "unique_identifier_msgs/msg/dds_opensplice/UUID_.h"
#include "builtin_interfaces/msg/dds_opensplice/Time_.h"


namespace nav2_msgs
{
    namespace action
    {
        namespace dds_
        {
            struct  FollowWaypoints_Goal_
            {
                struct _poses__seq_uniq_{};
                typedef DDS_DCPSUVLSeq< ::geometry_msgs::msg::dds_::PoseStamped_, struct _poses__seq_uniq_ > _poses__seq;
                typedef DDS_DCPSSequence_var< _poses__seq > _poses__seq_var;
                typedef DDS_DCPSSequence_out< _poses__seq > _poses__seq_out;
                _poses__seq poses_;
            };

            typedef DDS_DCPSStruct_var<FollowWaypoints_Goal_> FollowWaypoints_Goal__var;
            typedef DDS_DCPSStruct_out < FollowWaypoints_Goal_> FollowWaypoints_Goal__out;

            struct  FollowWaypoints_SendGoal_Request_
            {
                ::unique_identifier_msgs::msg::dds_::UUID_ goal_id_;
                ::nav2_msgs::action::dds_::FollowWaypoints_Goal_ goal_;
            };

            typedef DDS_DCPSStruct_var<FollowWaypoints_SendGoal_Request_> FollowWaypoints_SendGoal_Request__var;
            typedef DDS_DCPSStruct_out < FollowWaypoints_SendGoal_Request_> FollowWaypoints_SendGoal_Request__out;

            struct  FollowWaypoints_SendGoal_Response_
            {
                ::DDS::Boolean accepted_;
                ::builtin_interfaces::msg::dds_::Time_ stamp_;
            };

            typedef DDS_DCPSStruct_var<FollowWaypoints_SendGoal_Response_> FollowWaypoints_SendGoal_Response__var;
            typedef FollowWaypoints_SendGoal_Response_& FollowWaypoints_SendGoal_Response__out;

            struct  Sample_FollowWaypoints_SendGoal_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::nav2_msgs::action::dds_::FollowWaypoints_SendGoal_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_FollowWaypoints_SendGoal_Request_> Sample_FollowWaypoints_SendGoal_Request__var;
            typedef DDS_DCPSStruct_out < Sample_FollowWaypoints_SendGoal_Request_> Sample_FollowWaypoints_SendGoal_Request__out;

            struct  Sample_FollowWaypoints_SendGoal_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::nav2_msgs::action::dds_::FollowWaypoints_SendGoal_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_FollowWaypoints_SendGoal_Response_> Sample_FollowWaypoints_SendGoal_Response__var;
            typedef Sample_FollowWaypoints_SendGoal_Response_& Sample_FollowWaypoints_SendGoal_Response__out;

            struct  FollowWaypoints_Result_
            {
                struct _missed_waypoints__seq_uniq_{};
                typedef DDS_DCPSUFLSeq< ::DDS::Long, struct _missed_waypoints__seq_uniq_ > _missed_waypoints__seq;
                typedef DDS_DCPSSequence_var< _missed_waypoints__seq > _missed_waypoints__seq_var;
                typedef DDS_DCPSSequence_out< _missed_waypoints__seq > _missed_waypoints__seq_out;
                _missed_waypoints__seq missed_waypoints_;
            };

            typedef DDS_DCPSStruct_var<FollowWaypoints_Result_> FollowWaypoints_Result__var;
            typedef DDS_DCPSStruct_out < FollowWaypoints_Result_> FollowWaypoints_Result__out;

            struct  FollowWaypoints_GetResult_Request_
            {
                ::unique_identifier_msgs::msg::dds_::UUID_ goal_id_;
            };

            typedef DDS_DCPSStruct_var<FollowWaypoints_GetResult_Request_> FollowWaypoints_GetResult_Request__var;
            typedef FollowWaypoints_GetResult_Request_& FollowWaypoints_GetResult_Request__out;

            struct  FollowWaypoints_GetResult_Response_
            {
                ::DDS::Octet status_;
                ::nav2_msgs::action::dds_::FollowWaypoints_Result_ result_;
            };

            typedef DDS_DCPSStruct_var<FollowWaypoints_GetResult_Response_> FollowWaypoints_GetResult_Response__var;
            typedef DDS_DCPSStruct_out < FollowWaypoints_GetResult_Response_> FollowWaypoints_GetResult_Response__out;

            struct  Sample_FollowWaypoints_GetResult_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::nav2_msgs::action::dds_::FollowWaypoints_GetResult_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_FollowWaypoints_GetResult_Request_> Sample_FollowWaypoints_GetResult_Request__var;
            typedef Sample_FollowWaypoints_GetResult_Request_& Sample_FollowWaypoints_GetResult_Request__out;

            struct  Sample_FollowWaypoints_GetResult_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::nav2_msgs::action::dds_::FollowWaypoints_GetResult_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_FollowWaypoints_GetResult_Response_> Sample_FollowWaypoints_GetResult_Response__var;
            typedef DDS_DCPSStruct_out < Sample_FollowWaypoints_GetResult_Response_> Sample_FollowWaypoints_GetResult_Response__out;

            struct  FollowWaypoints_Feedback_
            {
                ::DDS::ULong current_waypoint_;
            };

            typedef DDS_DCPSStruct_var<FollowWaypoints_Feedback_> FollowWaypoints_Feedback__var;
            typedef FollowWaypoints_Feedback_& FollowWaypoints_Feedback__out;

            struct  FollowWaypoints_FeedbackMessage_
            {
                ::unique_identifier_msgs::msg::dds_::UUID_ goal_id_;
                ::nav2_msgs::action::dds_::FollowWaypoints_Feedback_ feedback_;
            };

            typedef DDS_DCPSStruct_var<FollowWaypoints_FeedbackMessage_> FollowWaypoints_FeedbackMessage__var;
            typedef FollowWaypoints_FeedbackMessage_& FollowWaypoints_FeedbackMessage__out;

        }

    }

}

#endif /* _H_2B00C1E74DE40F6CD5834F7742693179_FollowWaypoints__H_ */
