#ifndef _H_EF3A3B37E6AA0751F3E5E1E5D056F88D_Wait__H_
#define _H_EF3A3B37E6AA0751F3E5E1E5D056F88D_Wait__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "builtin_interfaces/msg/dds_opensplice/Duration_.h"
#include "unique_identifier_msgs/msg/dds_opensplice/UUID_.h"
#include "builtin_interfaces/msg/dds_opensplice/Time_.h"
#include "std_msgs/msg/dds_opensplice/Empty_.h"


namespace nav2_msgs
{
    namespace action
    {
        namespace dds_
        {
            struct  Wait_Goal_
            {
                ::builtin_interfaces::msg::dds_::Duration_ time_;
            };

            typedef DDS_DCPSStruct_var<Wait_Goal_> Wait_Goal__var;
            typedef Wait_Goal_& Wait_Goal__out;

            struct  Wait_SendGoal_Request_
            {
                ::unique_identifier_msgs::msg::dds_::UUID_ goal_id_;
                ::nav2_msgs::action::dds_::Wait_Goal_ goal_;
            };

            typedef DDS_DCPSStruct_var<Wait_SendGoal_Request_> Wait_SendGoal_Request__var;
            typedef Wait_SendGoal_Request_& Wait_SendGoal_Request__out;

            struct  Wait_SendGoal_Response_
            {
                ::DDS::Boolean accepted_;
                ::builtin_interfaces::msg::dds_::Time_ stamp_;
            };

            typedef DDS_DCPSStruct_var<Wait_SendGoal_Response_> Wait_SendGoal_Response__var;
            typedef Wait_SendGoal_Response_& Wait_SendGoal_Response__out;

            struct  Sample_Wait_SendGoal_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::nav2_msgs::action::dds_::Wait_SendGoal_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_Wait_SendGoal_Request_> Sample_Wait_SendGoal_Request__var;
            typedef Sample_Wait_SendGoal_Request_& Sample_Wait_SendGoal_Request__out;

            struct  Sample_Wait_SendGoal_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::nav2_msgs::action::dds_::Wait_SendGoal_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_Wait_SendGoal_Response_> Sample_Wait_SendGoal_Response__var;
            typedef Sample_Wait_SendGoal_Response_& Sample_Wait_SendGoal_Response__out;

            struct  Wait_Result_
            {
                ::std_msgs::msg::dds_::Empty_ result_;
            };

            typedef DDS_DCPSStruct_var<Wait_Result_> Wait_Result__var;
            typedef Wait_Result_& Wait_Result__out;

            struct  Wait_GetResult_Request_
            {
                ::unique_identifier_msgs::msg::dds_::UUID_ goal_id_;
            };

            typedef DDS_DCPSStruct_var<Wait_GetResult_Request_> Wait_GetResult_Request__var;
            typedef Wait_GetResult_Request_& Wait_GetResult_Request__out;

            struct  Wait_GetResult_Response_
            {
                ::DDS::Octet status_;
                ::nav2_msgs::action::dds_::Wait_Result_ result_;
            };

            typedef DDS_DCPSStruct_var<Wait_GetResult_Response_> Wait_GetResult_Response__var;
            typedef Wait_GetResult_Response_& Wait_GetResult_Response__out;

            struct  Sample_Wait_GetResult_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::nav2_msgs::action::dds_::Wait_GetResult_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_Wait_GetResult_Request_> Sample_Wait_GetResult_Request__var;
            typedef Sample_Wait_GetResult_Request_& Sample_Wait_GetResult_Request__out;

            struct  Sample_Wait_GetResult_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::nav2_msgs::action::dds_::Wait_GetResult_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_Wait_GetResult_Response_> Sample_Wait_GetResult_Response__var;
            typedef Sample_Wait_GetResult_Response_& Sample_Wait_GetResult_Response__out;

            struct  Wait_Feedback_
            {
                ::DDS::Octet structure_needs_at_least_one_member_;
            };

            typedef DDS_DCPSStruct_var<Wait_Feedback_> Wait_Feedback__var;
            typedef Wait_Feedback_& Wait_Feedback__out;

            struct  Wait_FeedbackMessage_
            {
                ::unique_identifier_msgs::msg::dds_::UUID_ goal_id_;
                ::nav2_msgs::action::dds_::Wait_Feedback_ feedback_;
            };

            typedef DDS_DCPSStruct_var<Wait_FeedbackMessage_> Wait_FeedbackMessage__var;
            typedef Wait_FeedbackMessage_& Wait_FeedbackMessage__out;

        }

    }

}

#endif /* _H_EF3A3B37E6AA0751F3E5E1E5D056F88D_Wait__H_ */
